org.apache.lucene.queryparser.flexible.standard.parser

## Class FastCharStream

- java.lang.Object
- - org.apache.lucene.queryparser.flexible.standard.parser.FastCharStream

All Implemented Interfaces:
  CharStream

    public final class FastCharStream
    extends Object
    implements CharStream

An efficient implementation of JavaCC's CharStream interface.

Note that this does not do line-number counting, but instead keeps track of the character position of the token in the input, as required by Lucene's `OffsetAttribute` API.

### Constructor Summary

Constructors
Constructor and Description
`FastCharStream(Reader r)` Constructs from a Reader.

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`void` `backup(int amount)` Backs up the input stream by amount steps.
`char` `BeginToken()` Returns the next character that marks the beginning of the next token.
`void` `Done()` The lexer calls this function to indicate that it is done with the stream and hence implementations can free any resources held by this class.
`int` `getBeginColumn()` Returns the column number of the first character for current token (being matched after the last call to BeginTOken).
`int` `getBeginLine()` Returns the line number of the first character for current token (being matched after the last call to BeginTOken).
`int` `getColumn()` Deprecated. see #getEndColumn
`int` `getEndColumn()` Returns the column number of the last character for current token (being matched after the last call to BeginTOken).
`int` `getEndLine()` Returns the line number of the last character for current token (being matched after the last call to BeginTOken).
`String` `GetImage()` Returns a string made up of characters from the marked token beginning to the current buffer position.
`int` `getLine()` Deprecated. see #getEndLine
`char[]` `GetSuffix(int len)` Returns an array of characters that make up the suffix of length 'len' for the currently matched token.
`char` `readChar()` Returns the next character from the selected input.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### FastCharStream

    public FastCharStream(Reader r)

Constructs from a Reader.

### Method Detail

#### readChar

    public final char readChar()
                        throws IOException

Description copied from interface: `CharStream`
Returns the next character from the selected input. The method of selecting the input is the responsibility of the class implementing this interface. Can throw any java.io.IOException.

Specified by:
  `readChar` in interface `CharStream`
Throws:
  `IOException`

#### BeginToken

    public final char BeginToken()
                          throws IOException

Description copied from interface: `CharStream`
Returns the next character that marks the beginning of the next token. All characters must remain in the buffer between two successive calls to this method to implement backup correctly.

Specified by:
  `BeginToken` in interface `CharStream`
Throws:
  `IOException`

#### backup

    public final void backup(int amount)

Description copied from interface: `CharStream`
Backs up the input stream by amount steps. Lexer calls this method if it had already read some characters, but could not use them to match a (longer) token. So, they will be used again as the prefix of the next token and it is the implementation's responsibility to do this right.

Specified by:
  `backup` in interface `CharStream`

#### GetImage

    public final String GetImage()

Description copied from interface: `CharStream`
Returns a string made up of characters from the marked token beginning to the current buffer position. Implementations have the choice of returning anything that they want to. For example, for efficiency, one might decide to just return null, which is a valid implementation.

Specified by:
  `GetImage` in interface `CharStream`

#### GetSuffix

    public final char[] GetSuffix(int len)

Description copied from interface: `CharStream`
Returns an array of characters that make up the suffix of length 'len' for the currently matched token. This is used to build up the matched string for use in actions in the case of MORE. A simple and inefficient implementation of this is as follows : { String t = GetImage(); return t.substring(t.length() - len, t.length()).toCharArray(); }

Specified by:
  `GetSuffix` in interface `CharStream`

#### Done

    public final void Done()

Description copied from interface: `CharStream`
The lexer calls this function to indicate that it is done with the stream and hence implementations can free any resources held by this class. Again, the body of this function can be just empty and it will not affect the lexer's operation.

Specified by:
  `Done` in interface `CharStream`

#### getColumn

    @Deprecated
    public final int getColumn()

Deprecated. see #getEndColumn
Returns the column position of the character last read.

Specified by:
  `getColumn` in interface `CharStream`

#### getLine

    @Deprecated
    public final int getLine()

Deprecated. see #getEndLine

Specified by:
  `getLine` in interface `CharStream`

#### getEndColumn

    public final int getEndColumn()

Description copied from interface: `CharStream`
Returns the column number of the last character for current token (being matched after the last call to BeginTOken).

Specified by:
  `getEndColumn` in interface `CharStream`

#### getEndLine

    public final int getEndLine()

Description copied from interface: `CharStream`
Returns the line number of the last character for current token (being matched after the last call to BeginTOken).

Specified by:
  `getEndLine` in interface `CharStream`

#### getBeginColumn

    public final int getBeginColumn()

Description copied from interface: `CharStream`
Returns the column number of the first character for current token (being matched after the last call to BeginTOken).

Specified by:
  `getBeginColumn` in interface `CharStream`

#### getBeginLine

    public final int getBeginLine()

Description copied from interface: `CharStream`
Returns the line number of the first character for current token (being matched after the last call to BeginTOken).

Specified by:
  `getBeginLine` in interface `CharStream`